//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%480CA1D802B7.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%480CA1D802B7.cm

//## begin module%480CA1D802B7.cp preserve=no
//## end module%480CA1D802B7.cp

//## Module: MdefContainer%480CA1D802B7; Package specification
//## Subsystem: XSModel::GlobalContainer%3E4293160205
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/GlobalContainer/MdefContainer.h

#ifndef MDEFCONTAINER_H
#define MDEFCONTAINER_H 1

//## begin module%480CA1D802B7.additionalIncludes preserve=no
//## end module%480CA1D802B7.additionalIncludes

//## begin module%480CA1D802B7.includes preserve=yes
//## end module%480CA1D802B7.includes

// MathExpression
#include <XSUtil/Parse/MathExpression.h>
// XSutility
#include <XSUtil/Utils/XSutility.h>
//## begin module%480CA1D802B7.declarations preserve=no
//## end module%480CA1D802B7.declarations

//## begin module%480CA1D802B7.additionalDeclarations preserve=yes
#include <xsTypes.h>
#include <XSUtil/FunctionUtils/XSModelFunction.h>
#include <utility>
//## end module%480CA1D802B7.additionalDeclarations


//## Modelname: XSModel::GlobalContainer%3E42929A0210
namespace XSContainer {
    //## begin XSContainer%3E42929A0210.initialDeclarations preserve=yes
    //## end XSContainer%3E42929A0210.initialDeclarations

    //## begin XSContainer::MdefContainer%480CA2B80150.preface preserve=yes
    //## end XSContainer::MdefContainer%480CA2B80150.preface

    //## Class: MdefContainer%480CA2B80150
    //## Category: XSModel::GlobalContainer%3E42929A0210
    //## Subsystem: XSModel::GlobalContainer%3E4293160205
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    //## Uses: <unnamed>%480CAFD800B1;MathExpression { -> }
    //## Uses: <unnamed>%4810F09902DC;XSutility::Nocase { -> }

    class MdefContainer 
    {
      //## begin XSContainer::MdefContainer%480CA2B80150.initialDeclarations preserve=yes
      //## end XSContainer::MdefContainer%480CA2B80150.initialDeclarations

      public:
        //## Class: CompPair%480F86B201AB
        //	The string refers to the type of component, ie. "add",
        //	etc.
        //## Category: XSModel::GlobalContainer%3E42929A0210
        //## Subsystem: XSModel::GlobalContainer%3E4293160205
        //## Persistence: Transient
        //## Cardinality/Multiplicity: n



        typedef std::pair<string,XSCall<MathExpression>*> CompPair;

      private:
        //## Class: CompMap%480F87120178; private
        //	The string is the component name.
        //## Category: XSModel::GlobalContainer%3E42929A0210
        //## Subsystem: XSModel::GlobalContainer%3E4293160205
        //## Persistence: Transient
        //## Cardinality/Multiplicity: n



        typedef std::map<string,CompPair,XSutility::Nocase > CompMap;

      public:
        //## Constructors (generated)
          MdefContainer();

        //## Destructor (generated)
          ~MdefContainer();


        //## Other Operations (specified)
          //## Operation: displayComponents%480CB30400AF
          void displayComponents () const;

          //## Operation: removeComponent%480CB3560065
          string removeComponent (const string& name);

          //## Operation: addComponent%480CBD43027C
          //	Returns false and will not create a new component if one
          //	with the same name already exists.
          bool addComponent (const string& name, const string& type, const string& expression, std::pair<Real,Real> eLimits);

          //## Operation: displayComponent%4810CF80021A
          void displayComponent (const string& name) const;

          //## Operation: getComponent%48162A9A013C
          MdefContainer::CompPair getComponent (const string& name) const;

        //## Get and Set Operations for Class Attributes (generated)

          //## Attribute: NOT_FOUND%4816302E01CB
          static const string& NOT_FOUND ();

        // Additional Public Declarations
          //## begin XSContainer::MdefContainer%480CA2B80150.public preserve=yes
          //## end XSContainer::MdefContainer%480CA2B80150.public

      protected:
        // Additional Protected Declarations
          //## begin XSContainer::MdefContainer%480CA2B80150.protected preserve=yes
          //## end XSContainer::MdefContainer%480CA2B80150.protected

      private:
        //## Constructors (generated)
          MdefContainer(const MdefContainer &right);

        //## Assignment Operation (generated)
          MdefContainer & operator=(const MdefContainer &right);

        // Additional Private Declarations
          //## begin XSContainer::MdefContainer%480CA2B80150.private preserve=yes
          //## end XSContainer::MdefContainer%480CA2B80150.private

      private: //## implementation
        // Data Members for Class Attributes

          //## Attribute: components%480F8654024B
          //## begin XSContainer::MdefContainer::components%480F8654024B.attr preserve=no  private: XSContainer::MdefContainer::CompMap {U} 
          XSContainer::MdefContainer::CompMap m_components;
          //## end XSContainer::MdefContainer::components%480F8654024B.attr

          //## begin XSContainer::MdefContainer::NOT_FOUND%4816302E01CB.attr preserve=no  public: static string {UC} string("hN#@xnNOT_FOUNDp!749w9q")
          static const string s_NOT_FOUND;
          //## end XSContainer::MdefContainer::NOT_FOUND%4816302E01CB.attr

        // Additional Implementation Declarations
          //## begin XSContainer::MdefContainer%480CA2B80150.implementation preserve=yes
          //## end XSContainer::MdefContainer%480CA2B80150.implementation

    };

    //## begin XSContainer::MdefContainer%480CA2B80150.postscript preserve=yes
    //## end XSContainer::MdefContainer%480CA2B80150.postscript

    // Class XSContainer::MdefContainer 

    //## Get and Set Operations for Class Attributes (inline)

    inline const string& MdefContainer::NOT_FOUND ()
    {
      //## begin XSContainer::MdefContainer::NOT_FOUND%4816302E01CB.get preserve=no
      return s_NOT_FOUND;
      //## end XSContainer::MdefContainer::NOT_FOUND%4816302E01CB.get
    }

} // namespace XSContainer

//## begin module%480CA1D802B7.epilog preserve=yes
//## end module%480CA1D802B7.epilog


#endif
